Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 77014 - dhclient recreates /etc/resolv.conf on all lease renewals
Summary: dhclient recreates /etc/resolv.conf on all lease renewals
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Red Hat Linux
Classification: Retired
Component: dhcp
Version: 8.0
Hardware: i686
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Daniel Walsh
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2002-10-30 23:59 UTC by Kyle Gonzales
Modified: 2007-04-18 16:48 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2003-08-01 19:22:50 UTC


Attachments (Terms of Use)

Description Kyle Gonzales 2002-10-30 23:59:54 UTC
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.0.1) Gecko/20021003

Description of problem:
dhclient recreates /etc/resolv.conf on ALL lease renewals, even if no new or
changed information is pulled from the DHCP server.  It breaks anything that
needs something to be temporarily entered manually into /etc/resolv.conf, and
breaks VPN clients that change /etc/resolv.conf to different values while they
are enabled.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Bring up an interface using DHCP
2. Once you have an address and your resolv.conf info, make a change manually to
the resolv.conf file
3. Wait for the lease to renew
	

Actual Results:  The manual changes will be removed from the file when the DHCP
lease renews.

Expected Results:  Like with dhcpcd, dhclient should do nothing is no new
information is brought in from the DHCP server.

Additional info:

This is causing problems with people using the Cisco VPN client with 8.0.  This
behavior does not occur on RH 7.2 using dhcpcd.

I will dig into the /sbin/dhclient-script file (which is the culprit) and see if
I can't write a workaround for this.

Comment 1 Eugene Kanter 2002-12-26 03:58:29 UTC
This creates huge problems when two network cards are active and at least one managed by a 
DHCP. Let's say that eth0 is configured by DHCP. After ifdown eth0 /etc/resolv.conf gets 
cleared out and system is left without DNS. Problem is still present in Phoebe. 

Comment 2 Daniel Walsh 2003-01-14 22:29:44 UTC
Two things.  I propose making a change so that Renew will not update the
resolv.conf.  Secondly if you don't want the dhcp messing with /etc/resolv.conf
at all you need to set PEERDNS to no

Comment 3 Eugene Kanter 2003-01-15 03:10:11 UTC
Not clear how problem with two network cards can be solved.

Comment 4 Eugene Kanter 2003-07-29 15:54:17 UTC
Any more comments on two network cards issue? Has anybody tested this on 9 or 
current beta?

Comment 5 Daniel Walsh 2003-08-01 19:22:50 UTC
I have changed the script to not rewrite the resolv.conf on renew.  Also if you
are using two cards you should turn off peerdns and configure resolv.conf
manually.  This will be in rawhide as dhcp-3.0pl2-6.10

Comment 6 Kyle Gonzales 2003-08-01 20:18:27 UTC
Excellent!  Will this bugfix be backported to 8.0 and 9?


Note You need to log in before you can comment on or make changes to this bug.